{%- from "openssh/map.jinja" import client with context %}
{%- if client.enabled %}

include:
- openssh.client.service

  {%- for xxx, user in client.get('user', {}).iteritems() %}
    {%- if user.private_key is defined %}


{{ user.user.home }}/.ssh_dir_for_key:
  file.directory:
  - names:
    - {{ user.user.home }}/.ssh
  - user: {{ user.user.name }}
  - mode: 700
  - makedirs: true

{{ user.user.home }}/.ssh/id_{{ user.private_key.type }}:
  file.managed:
  - user: {{ user.user.name }}
  - source: salt://openssh/files/private_key
  - mode: 400
  - template: jinja
  - defaults:
    user_name: {{ user.user.name }}
  - require:
    - file: {{ user.user.home }}/.ssh_dir_for_key

      {%- if user.public_key is defined %}
{{ user.user.home }}/.ssh/id_{{ user.private_key.type }}.pub:
  file.managed:
  - user: {{ user.user.name }}
  - source: salt://openssh/files/public_key
  - mode: 400
  - template: jinja
  - defaults:
    user_name: {{ user.user.name }}
  - require:
    - file: {{ user.user.home }}/.ssh_dir_for_key
      {%- endif %}
    {%- endif %}
  {%- endfor %}
{%- endif %}
